;
$DATE (22.12.2019)
$TITLE (DSqrtTest)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;************************************************************************
; Testprogramm fr Quadratwurzel
; J. Rathlev, Dez. 2019
;************************************************************************

      NAME      DSqrtTest 

;************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H 

;************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

;************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

;************************************************************************
; Hauptprogramm

        ORG     CODEMEM+30H

$INCLUDE(Sqrt.a51)
$INCLUDE(DSqrt.a51)

V1:     DB      040H,042H,00FH,00H       ; = 1000000 (Little-Endian-Format)
V2:     DB      010H,027H                ; = 10000
; Ergebnisse fr Testwerte:
; Sqrt(V1) =  1000 = 3E8H
; Sqrt(V2) =  100  = 064H

; Programmstart
Start:  MOV     SP,#STACKSTART

LOOP:
        MOV     DPTR,#V2
        MOV     R0,#RADI
        CALL    MOVCD2
        CALL    SQRT8

        MOV     DPTR,#V1
        MOV     R0,#DRADI
        CALL    MOVCD4
        CALL    SQRT16

        SJMP    LOOP            ; Endlosschleife


;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; Stack: Rest des Datenspeichers

END
