;
$DATE (10.12.2003)
$TITLE (dectobin.a51)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;

;********************************************************************************************************
; Lesen einer Zahl (0 .. 255) ber die serielle Schnittstelle (direkt), Umsetzen in Binrwert und 
; Anzeigen an LED (Port 1)
; J. Rathlev, Dez. 2003
;********************************************************************************************************

      NAME      DECTOBIN

;********************************************************************************************************
; Konstanten
; ==========

CODEMEM EQU     8000H

LED     EQU     P1.7    ; Portanschluss fr LED

;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start

;********************************************************************************************************

        ORG     CODEMEM+30H

$INCLUDE(SerInOut.a51)

;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        MOV     A,#250          ; BR-Count (Serint.a51)
        CALL    InitSerial
        MOV     DPTR,#TEXT1     ; Begrungstext
        CALL    WRITEFIXSTR

NEW:    MOV     R0,#0           ; Ergebnis inital.
        MOV     DPTR,#TEXT2     ; Eingabeaufforderung
        CALL    WRITEFIXSTR

LOOP:   JNB     RI,LOOP         ; auf Zeichen warten
        CLR     RI
        MOV     A,SBUF          ; Zeichen lesen
        CALL    WRITECHAR       ; Echo
        CLR     C
        SUBB    A,#30H          ; - 48
        JC      DONE            ; < 48 ('0')
        SUBB    A,#0AH          ; - 10
        JNC     DONE            ; > 9  ('9')
        ADD     A,#0AH          ; Wert 0 .. 9
        MOV     R1,A            ; zwischenspeichern
        MOV     A,R0            ; Ergebnis holen
        MOV     B,#10D
        MUL     AB              ; * 10
        ADD     A,R1            ; addiere nchste Stelle
        MOV     R0,A            ; Ergebnis speichern
        SJMP    LOOP

DONE:   MOV     A,R0            ; Ende der Zahl
        CPL     A
        MOV     P1,A            ; auf LEDs anzeigen
        SJMP    NEW



TEXT1:   DB     'Hallo, hier ist der Mikrocontroller!',0
TEXT2:   DB     13,10,'Geben Sie eine Zahl ein: ',0

;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; stack: rest of data memory

END
