;$NOLIST
;
;********************************************************************************************************
; Multiplikation und Division mit 16 Bit
; J. Rathlev, Dez. 2003
; Diese Datei kann mit der Include-Anweisung in andere Programme integriert werden
;********************************************************************************************************

        DSEG

FAK1:   DS      2
FAK2:   DS      2
PROD:   DS      4
DIVI:   DS      2
QUOT:   DS      2

;********************************************************************************************************

        CSEG

;********************************************************************************************************
; Multiplikation (ca. 55s bei 12 MHz)
; Faktoren in FAK1 und FAK2 (16 Bit)
; Produkt in PROD (32 Bit)
; benutzte Register: A,B
;********************************************************************************************************

MUL16:  MOV  A,FAK1+0    
        MOV  B,FAK2+0
        MUL  AB          ; low * low byte
        MOV  PROD+0,A
        MOV  PROD+1,B
        MOV  A,FAK1+1
        MOV  B,FAK2+1
        MUL  AB          ; high * high byte
        MOV  PROD+2,A
        MOV  PROD+3,B
        MOV  A,FAK1+1    ; mixed prod 1
        MOV  B,FAK2+0
        MUL  AB
        ADD  A,PROD+1    ; add 3 byte wide
        MOV  PROD+1,A
        MOV  A,PROD+2
        ADDC A,B
        MOV  PROD+2,A
        MOV  A,PROD+3
        ADDC A,#0
        MOV  PROD+3,A
        MOV  A,FAK1+0    ; mixed prod 2
        MOV  B,FAK2+1
        MUL  AB
        ADD  A,PROD+1    ; add 3 byte wide
        MOV  PROD+1,A
        MOV  A,PROD+2
        ADDC A,B
        MOV  PROD+2,A
        MOV  A,PROD+3
        ADDC A,#0
        MOV  PROD+3,A
        RET

;********************************************************************************************************
; Division (ca. 435s bei 12MHz)
; Dividend in PROD (32 Bit)
; Divisor in DIVI (16 Bit)
; Quotient in QUOT (16 Bit)
; benutzte Register: A,R7
; Achtung: keine Prfung auf berlauf
;          d.h. PROD / 2^16 < DIVI
;********************************************************************************************************

DIV16:  MOV     R7,#16          ; Zhler

DLOOP:  CLR     C
        MOV     A,PROD          ; Produkt 1 Bit nach links
        RLC     A
        MOV     PROD,A
        MOV     A,PROD+1
        RLC     A
        MOV     PROD+1,A
        MOV     A,PROD+2
        RLC     A
        MOV     PROD+2,A
        MOV     A,PROD+3
        RLC     A
        MOV     PROD+3,A
        JNC     DIV16B
        CLR     C               ; MSB gesetzt - immer subtrahieren
        MOV     A,PROD+2        
        SUBB    A,DIVI
        MOV     PROD+2,A 
        MOV     A,PROD+3
        SUBB    A,DIVI+1        ; Differenz nach PROD
        SJMP    DIV16C

DIV16B: CLR     C
        MOV     A,PROD+2        ; subtrahiere Divisor probeweise
        SUBB    A,DIVI
        MOV     QUOT,A          ; zwischenspeichern
        MOV     A,PROD+3
        SUBB    A,DIVI+1
        JC      DIV16A          ; passt nicht rein
        MOV     PROD+2,QUOT
DIV16C: MOV     PROD+3,A        ; ok - Differenz nach PROD
        INC     PROD            ; setze Bit im Ergebnis
DIV16A: DJNZ    R7,DLOOP
        MOV     QUOT,PROD
        MOV     QUOT+1,PROD+1
        CLR     C
        RET

OFLERR: SETB    C
        RET
$LIST
